**************************************************
*-- Class:        structure (c:\work\vfp_prg\fox98\prglib98\mststruc.vcx)
*-- ParentClass:  serverclass (c:\work\vfp_prg\fox98\prglib98\server.vcx)
*-- BaseClass:    line
*-- Time Stamp:   10/15/00 11:04:05 PM
*
#DEFINE SECTION_STRUCTURE 	";"
#DEFINE SECTION_MEMBERS		SPACE(1)
#DEFINE Nil					CHR(0)

*
DEFINE CLASS structure AS Line


	*--           
	structurestring = ""
	Name = "structure"
	HIDDEN linternal
	HIDDEN members_arr[1]
	HIDDEN keyword_arr[1,2]
	HIDDEN height
	HIDDEN width
	HIDDEN classlibrary
	HIDDEN addproperty
	HIDDEN baseclass
	HIDDEN bordercolor
	HIDDEN borderstyle
	HIDDEN class
	HIDDEN click
	HIDDEN cloneobject
	HIDDEN colorsource
	HIDDEN dblclick
	HIDDEN drag
	HIDDEN dragdrop
	HIDDEN dragicon
	HIDDEN dragmode
	HIDDEN dragover
	HIDDEN drawmode
	HIDDEN enabled
	HIDDEN lineslant
	HIDDEN middleclick
	HIDDEN mousedown
	HIDDEN mouseicon
	HIDDEN mousemove
	HIDDEN mousepointer
	HIDDEN mouseup
	HIDDEN mousewheel
	HIDDEN move
	HIDDEN olecompletedrag
	HIDDEN oledrag
	HIDDEN oledragdrop
	HIDDEN oledragmode
	HIDDEN oledragover
	HIDDEN oledragpicture
	HIDDEN oledropeffects
	HIDDEN oledrophasdata
	HIDDEN oledropmode
	HIDDEN olegivefeedback
	HIDDEN olesetdata
	HIDDEN olestartdrag
	HIDDEN parent
	HIDDEN parentclass
	HIDDEN readexpression
	HIDDEN readmethod
	HIDDEN resettodefault
	HIDDEN rightclick
	HIDDEN saveasclass
	HIDDEN showwhatsthis
	HIDDEN uienable
	HIDDEN visible
	HIDDEN writeexpression
	HIDDEN writemethod
	HIDDEN zorder
	HIDDEN borderwidth
	HIDDEN helpcontextid
	HIDDEN whatsthishelpid


	HIDDEN PROCEDURE addmembers
		lParameters tcMembers,tnCount
		Local x,lcKeyword,lcType,lnSize,lcName,lcValue
		WITH THIS
			Local lcType,lcName,lnPos
			lnPos=AT(SECTION_MEMBERS,tcMembers,1)
			lcKeyword=UPPER(substr(tcMembers,1,lnPos-1))
			lcName=substr(tcMembers,lnPos+1)
			dimension .Members_arr(tnCount,3)
			for x=1 to alen(.keyword_arr,1)
				if lcKEYWORD=.KEYWORD_ARR[x,1]
					lnSize=.KEYWORD_ARR[x,2]
					lcType=.KEYWORD_ARR[x,3]
					exit
				endif
			next
			.Members_arr(tnCount,1)=lcName
			if empty(lnSize) or empty(lcType)
				lnSize=1
				lcType="C"
			endif
			.Members_arr(tnCount,2)=lnSize
			.Members_arr(tnCount,3)=lcType
			lcValue=iif(lcType="N",0,Nil)
			.AddProperty(lcName,lcValue)
		ENDWITH
	ENDPROC


	HIDDEN PROCEDURE structurestring_access
		*To do: Modify this routine for the Access method
		Local lcName,x,lcRetString
		WITH This
			.lInternal=.T.
			.structurestring=""
			for x=1 to Alen(.Members_arr,1)
				lcName=.Members_arr[x,1]
				lnSize=.Members_arr[x,2]
				lcType=.Members_arr[x,3]
				if lcType="N" and VARTYPE(.&lcName)="N"
					.StructureString=.StructureString+._10to256(.&lcName,lnSize)
				else
					.StructureString=.StructureString+.&lcName
				endif
			next
			.lInternal=.F.
		ENDWITH
		RETURN THIS.structureString
	ENDPROC


	HIDDEN PROCEDURE structurestring_assign
		LPARAMETERS vNewVal
		WITH THIS
			if not .lInternal
				Local lcString,x,lnSize,lcName,lcType,lcVal,lnPos
				lnPos=1
				for x=1 to alen(.Members_arr,1)
					lcName=.members_arr[x,1]
					lnSize=.Members_arr[x,2]
					lcType=.Members_arr[x,3]
					lcValue=substr(m.vNewVal,lnPos,lnSize)
					lnPos=lnPos+lnSize
					if lcType="N"
						.&lcName=._256to10(lcValue,0)
					else
						.&lcName=lcValue
					endif
				next
			endif
			.structureString = m.vNewVal
		ENDWITH
	ENDPROC


	HIDDEN PROCEDURE _10to256
		*FUNCTION _10to256(lnNum, lnCant)
		*==========================================================
		* Autor: LMG - 1998.09.14
		*==========================================================
		*     
		*:
		*	lnNum  -   
		*	lnCant - - .
		*=========================================================
		lParameters lnNum,lnCant
		LOCAL lcRetorno, lnAscii

		lcRetorno=''
		DO WHILE lnNum >= 256
		   lnAscii=MOD(lnNum,256)
		   lcRetorno=lcRetorno + CHR(lnAscii)
		   lnNum=INT(lnNum / 256)
		ENDDO
		lnAscii=lnNum
		lcRetorno=lcRetorno + CHR(lnAscii)
		RETURN PADR(lcRetorno, lnCant, CHR(0))
	ENDPROC


	PROCEDURE sizeof
		*--     
		*--, ,  ,  
		*--  
		Local x,lcName,lcType,lnSize,lnRetVal
		WITh THIS
			lnRetVal=0
			for x=1 to alen(.Members_arr,1)
				lcName=.Members_arr[x,1]
				lnSize=.Members_arr[x,2]
				lcType=.Members_arr[x,3]
				lnRetVal=lnRetVal+iif(lcType="N",lnSize,len(.&lcName))
			next
		ENDWITH
		retu lnRetVal
	ENDPROC


	HIDDEN PROCEDURE _256to10
		*==========================================================
		*FUNCTION _256to10(lcPar, lnCant)
		*==========================================================
		* Autor: LMG - 1998.09.14
		*==========================================================
		*    
		*  
		*:
		*	lcPar  -   
		*	lnCant - - .
		*==========================================================
		lParameters lcPar,lnCant
		Local lnRet
		lnRet=0
		lnExp=1
		for x=1 to len(lcPar)
			lnRet=lnRet+(ASC(SUBSTR(lcPar,x,1))*lnExp)
			lnExp=lnExp*256
		next
		retu lnRet
		*retu ASC(SUBSTR(lcPar,2)) * 256 +ASC(SUBSTR(lcPar,1))
	ENDPROC


	PROCEDURE Init
		lParameters tcStructure,tnCountMembers
		*******************************************************
		*--     
		*--      -
		*--   
		*--   
		*!*	#DEFINE STRUCT_DCB "DWORD DCBlength;"+;
		*!*				"DWORD BaudRate;"+;
		*!*				"DWORD fBinary;"+;
		*!*				"DWORD fParity;"+;
		*!*				"DWORD fOutxCtsFlow;"+;
		*!*				"DWORD fOutxDsrFlow;"+;
		*!*				"DWORD fDtrControl;"+;
		*!*				"DWORD fDsrSensitivity;"+;
		*!*				"DWORD fTXContinueOnXoff;"+;
		*!*				"DWORD fOutX;"+;
		*!*				"DWORD fInX;"+;
		*!*				"DWORD fErrorChar;"+;
		*!*				"DWORD fNull;"+;
		*!*				"DWORD fRtsControl;"+;
		*!*				"DWORD fAbortOnError;"+;
		*!*				"DWORD fDummy2;"+;
		*!*				"WORD wReserved;"+;
		*!*				"WORD XonLim;"+;
		*!*				"WORD XoffLim;"+;
		*!*				"BYTE ByteSize;"+;
		*!*			    "BYTE Parity;"+;
		*!*			    "BYTE StopBits;"+;
		*!*			    "char XonChar;"+;
		*!*			    "char XoffChar;"+;
		*!*			    "char ErrorChar;"+;
		*!*			    "char EofChar;"+;
		*!*			    "char EvtChar;"+;
		*!*				"WORD wReserved1;" 
		********************************************************
		if VARTYPE(tcStructure)#"C"
			retu .f.
		endif
		**********************************************
		*--   - , 
		*--    
		dimension This.KEYWORD_arr[5,3]
		This.keyword_arr[1,1]="BYTE" &&  
		This.keyword_arr[1,2]=1		&& - 
		This.keyword_arr[1,3]="N"	&& 
		This.keyword_arr[2,1]="WORD"
		This.keyword_arr[2,2]=2
		This.keyword_arr[2,3]="N"	&& 
		This.keyword_arr[3,1]="DWORD"
		This.keyword_arr[3,2]=4
		This.keyword_arr[3,3]="N"	&& 
		This.keyword_arr[4,1]="CHAR"
		This.keyword_arr[4,2]=1
		This.keyword_arr[4,3]=""	&& 
		THIS.keyword_arr[5,1]="STRING"
		THIS.keyword_arr[5,2]=1
		THIS.keyword_arr[5,3]="C"
		*--    
		*--  CHAR,   
		**************************************************
		*--       
		*--    
		if RIGHT(tcStructure,1)#SECTION_STRUCTURE
			tcStructure=tcStructure+SECTION_STRUCTURE
		endif
		tnCountMembers=OCCURS(SECTION_STRUCTURE,tcStructure)
		Local x,lcMembers,lnStart,lnEnd
		lnStart=1
		for x=1 to tnCountMembers
			lnEnd=AT(SECTION_STRUCTURE,tcStructure,x)
			lcMembers=substr(tcStructure,lnStart,lnEnd-lnStart)
			lnStart=lnEnd+1
			This.AddMembers(lcMembers,x)
		next
	ENDPROC


ENDDEFINE
*
*-- EndDefine: structure
**************************************************

